import { Observable } from "rxjs";
export declare enum ProcessingType {
    EXHAUST = 0,
    CONCAT = 1,
    MERGE = 2,
    SWITCH = 3,
    FLAT = 4
}
export declare type PlainObjectType = string | number | boolean | Date;
export interface PlainObject {
    [key: string]: PlainObject | PlainObjectType | PlainObjectType[] | PlainObject[];
}
export interface IRetryProcessing {
    maxRetryAttempts: number;
    interval: number;
    typeInterval?: "LINEAR" | "EXPONENTIAL";
    retryWhenStatus?: number[];
    notRetryWhenStatus?: number[];
    retryWhen?: (error: any) => boolean;
    noRetryWhen?: (error: any) => boolean;
}
export interface IAsyncCallConfig {
    executeFn$?: (params: any) => any | Promise<any> | Observable<any>;
    retry?: IRetryProcessing;
    onProcessingStatus?: (processingStatus: IProcessingStatus, params: PlainObject) => void;
}
export declare type EnumStatusType = "PROCESSING" | "SUCCESS" | "ERROR" | "CANCELED";
export interface IProcessingStatus<T = any> {
    status?: EnumStatusType;
    data?: T;
    error?: any;
    config?: any;
}
