import { useEffect, useRef, useState } from "react";
import { delay, filter, Subject, takeUntil, tap } from "rxjs";
import { FormGroup } from "../../../model";
export const useFormGroup = formGroup => {
  const [, state] = useState({});
  const [, reRender] = useState(0);
  const formGroupRef = useRef(formGroup || new FormGroup({}));
  const setFormGroup$ = new Subject();
  const destroy$ = new Subject();
  useEffect(() => {
    setFormGroup$.pipe(takeUntil(destroy$), filter(formGroup => formGroup !== formGroupRef.current), tap(formGroup => {
      setImmediate(() => {
        formGroupRef.current = formGroup;
        formGroupRef.current.dispatchStateFn = state;
      });
    }), delay(1), tap(() => {
      reRender(Math.random());
    })).subscribe();
  }, []);
  return {
    formGroup: formGroupRef.current,
    setFormGroup: setFormGroup$.next.bind(setFormGroup$),
    getFormGroup: () => {
      return formGroupRef.current;
    }
  };
};