"use strict";

exports.__esModule = true;
exports.useEmitListen = void 0;

var _react = require("react");

var _rxjs = require("rxjs");

const useEmitListen = (props = {}) => {
  const emitListen$Ref = (0, _react.useRef)(new _rxjs.Subject());
  const destroy$Ref = (0, _react.useRef)(props.destroy$ ? props.destroy$ : new _rxjs.Subject());
  const stateRef = (0, _react.useRef)("OPEN");
  const open$Ref = (0, _react.useRef)(new _rxjs.Subject());
  const open$ = open$Ref.current;
  const close$Ref = (0, _react.useRef)(new _rxjs.Subject());
  const close$ = close$Ref.current;
  const destroy$ = destroy$Ref.current;
  const listenFnSubject$Ref = (0, _react.useRef)(new _rxjs.Subject());
  const listenFnsRef = (0, _react.useRef)([]);
  (0, _react.useEffect)(() => {
    listenFnSubject$Ref.current.pipe((0, _rxjs.takeUntil)(destroy$Ref.current), (0, _rxjs.tap)(listenFn => {
      listenFnsRef.current.push(listenFn);
    })).subscribe();
    (props.params$ ? (0, _rxjs.merge)(props.params$.pipe((0, _rxjs.debounceTime)(1)), emitListen$Ref.current) : emitListen$Ref.current).pipe((0, _rxjs.takeUntil)(destroy$Ref.current), (0, _rxjs.filter)(x => {
      return stateRef.current === "OPEN";
    }), (0, _rxjs.tap)(x => {
      props.tap && props.tap(x);
      listenFnsRef.current.forEach(listenFn => {
        listenFn(x);
      });
    }), (0, _rxjs.shareReplay)()).subscribe();
    open$.pipe((0, _rxjs.takeUntil)(destroy$), (0, _rxjs.tap)(() => {
      stateRef.current = "OPEN";
    })).subscribe();
    close$.pipe((0, _rxjs.takeUntil)(destroy$), (0, _rxjs.tap)(() => {
      stateRef.current = "CLOSE";
    })).subscribe();
    return () => {
      destroy$.next();
      destroy$.complete();
    };
  }, [destroy$, close$, open$, props]);
  return {
    emit: emitListen$Ref.current.next.bind(emitListen$Ref.current),
    listen: listenFnSubject$Ref.current.next.bind(listenFnSubject$Ref.current),
    open: open$Ref.current.next.bind(open$Ref.current),
    close: close$Ref.current.next.bind(close$Ref.current),
    state: stateRef.current
  };
};

exports.useEmitListen = useEmitListen;